---
title: DirectoryEntrySync
slug: Web/API/DirectoryEntrySync
tags:
  - API
  - File API
  - File System API
  - Offline
  - Reference
  - Référence(2)
  - filesystem
---
<p>{{APIRef("File System API")}}{{Non-standard_header}}</p>

<p>The <code>DirectoryEntrySync</code> interface of the <a href="/en/DOM/File_API/File_System_API" title="en/DOM/File_API/File_System_API">File System API</a> represents a directory in a file system. It includes methods for creating, reading, looking up, and recursively removing files in a directory.</p>

<div class="note">
<p>This interface has been abandonned: it was on a standard track and it proves not a good idea. Do not use it anymore.</p>
</div>

<h2 id="About_this_document">About this document</h2>

<p>This document was last updated on March 2, 2012 and follows the <a class="external" href="http://www.w3.org/TR/file-system-api/">W3C Specifications (Working Draft)</a> drafted on April 19, 2011.</p>

<p>This specification is pretty much abandoned, having failed to reach any substantial traction.</p>

<h2 id="basic_concepts">Basic concepts</h2>

<p>If you want to create subdirectories, you have to create each child directory in sequence. If you try to create a directory using a full path that includes parent directories that do not exist yet, you get an error. So create the hierarchy by recursively adding a new path after creating the parent directory.</p>

<h4 id="example">Example</h4>

<p>The <code>getFile()</code> method returns a <code>FileEntrySync</code>, which represents a file in the file system.  The following creates an empty file called <code>seekrits.txt</code> in the root directory.</p>

<pre class="brush: js">var fileEntry = fs.root.getFile('seekrits.txt', {create: true});
</pre>

<p>The <code>getDirectory()</code> method returns a <code>DirectoryEntrySync</code>, which represents a file in the file system. The following creates a new directory called <code>superseekrit</code> in the root directory.</p>

<pre>var dirEntry = fs.root.getDirectory('superseekrit', {create: true});</pre>

<h2 id="Method_overview">Method overview</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<td><code>DirectoryReaderSync <a href="#createReader">createReader</a> () raises (<a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a>);</code></td>
		</tr>
		<tr>
			<td><code><a href="/en/DOM/File_API/File_System_API/FileEntrySync" title="en/DOM/File_API/File_System_API/FileEntrySync">FileEntrySync</a> <a href="#getFile">getFile</a> (in DOMString <em>path</em>, in optional Flags <em>options</em>) raises (<a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a>);</code></td>
		</tr>
		<tr>
			<td><code>DirectoryEntrySync <a href="#getDirectory">getDirectory</a> (in DOMString path, in optional Flags <em>options</em>) raises (<a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a>);</code></td>
		</tr>
		<tr>
			<td><code>void <a href="#removeRecursively">removeRecursively</a> () raises (<a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a>); </code></td>
		</tr>
	</tbody>
</table>

<h2 id="Methods">Methods</h2>

<h3 id="createReader">createReader()</h3>

<p>Creates a new <code>DirectoryReaderSync</code> to read entries from this directory.</p>

<pre>DirectoryReaderSync createReader (
) raises (<a href="https://developer.mozilla.org/en/DOM/File_API/File_System_API/FileException">FileException</a>);</pre>

<h5 id="Returns">Returns</h5>

<dl>
	<dt><code><a href="/en/DOM/File_API/File_System_API/DirectoryReaderSync" title="en/DOM/File_API/File_System_API/DirectoryReaderSync">DirectoryReaderSync</a></code></dt>
	<dd>Represents a directory in a file system.</dd>
</dl>

<h5 id="Parameter">Parameter</h5>

<p>None</p>

<h5 id="Exceptions">Exceptions</h5>

<p>This method can raise a <a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a> with the following codes:</p>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Exception</th>
			<th scope="col">Description</th>
		</tr>
		<tr>
			<td><code>NOT_FOUND_ERR</code></td>
			<td>The directory does not exist.</td>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><code>SECURITY_ERR</code></td>
			<td>The browser determined that it was not safe to look up the metadata. [ todo: Explain why ]</td>
		</tr>
	</tbody>
</table>

<h3 id="getFile">getFile()</h3>

<p>Depending on how you've set the <code>options</code> parameter, the method either creates a file or looks up an existing file.</p>

<pre>void getFile (
  in DOMString <em>path</em>, in optional Flags <em>options</em>
) raises (<a href="https://developer.mozilla.org/en/DOM/File_API/File_System_API/FileException">FileException</a>);</pre>

<h5 id="Parameter_2">Parameter</h5>

<dl>
	<dt>path</dt>
	<dd>Either an absolute path or a relative path from the directory to the file to be looked up or created. You cannot create a file whose immediate parent does not exist. Create the parent directory first.</dd>
	<dt>options</dt>
	<dd>An object literal describing the behavior of the method. If the file does not exist, it is created.</dd>
</dl>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Object literal</th>
			<th scope="col">Condition</th>
			<th scope="col">Result</th>
		</tr>
		<tr>
			<td><code>create: true</code><br>
			<code>exclusive: true</code></td>
			<td>Path already exists</td>
			<td>An error is thrown.</td>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><code>create: true</code><br>
			<code>exclusive: false</code></td>
			<td>Path doesn't exist and no other error occurs</td>
			<td>A file is created. If a file already exists, no error is thrown.</td>
		</tr>
		<tr>
			<td><code>create: false</code><br>
			(<code>exclusive</code> is ignored)</td>
			<td>Path exists</td>
			<td>The file is returned.</td>
		</tr>
		<tr>
			<td><code>create: false</code><br>
			(<code>exclusive</code> is ignored)</td>
			<td>Path doesn't exist</td>
			<td>An error is thrown.</td>
		</tr>
		<tr>
			<td><code>create: false</code><br>
			(<code>exclusive</code> is ignored)</td>
			<td>Path exists, but is a directory</td>
			<td>An error is thrown.</td>
		</tr>
	</tbody>
</table>

<h5 id="Returns_2">Returns</h5>

<dl>
	<dt><a href="/en/DOM/File_API/File_System_API/FileEntrySync" title="en/DOM/File_API/File_System_API/FileEntrySync"><code>FileEntrySync</code></a></dt>
	<dd>Represents a file in a file system.</dd>
</dl>

<h5 id="Exceptions_2">Exceptions</h5>

<p>This method can raise a <a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a> with the following codes:</p>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Exception</th>
			<th scope="col">Description</th>
		</tr>
		<tr>
			<td><code>ENCODING_ERR</code></td>
			<td>The path supplied is invalid.</td>
		</tr>
		<tr>
			<td><code>NOT_FOUND_ERR</code></td>
			<td>The path was structurally correct, but refers to a resource that does not exist.</td>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><code>NO_MODIFICATION_ALLOWED_ERR</code></td>
			<td>This is a permission issue. The target directory or file is not writable.</td>
		</tr>
		<tr>
			<td><code>PATH_EXISTS_ERR</code></td>
			<td>The file already exists. You cannot create another one with the same path.</td>
		</tr>
		<tr>
			<td><code>QUOTA_EXCEEDED_ERROR</code></td>
			<td>The operation would cause the application to exceed its storage quota.</td>
		</tr>
		<tr>
			<td><code>SECURITY_ERR</code></td>
			<td>The application does not have permission to access the element referred to by path. [ todo: Explain why ]</td>
		</tr>
		<tr>
			<td><code>TYPE_MISMATCH_ERR</code></td>
			<td>The path supplied exists, but it is not a directory.</td>
		</tr>
	</tbody>
</table>

<h3 id="getDirectory">getDirectory()</h3>

<p>Creates or looks up a directory. The method is similar to <code>getFile()</code> with DirectoryEntrySync being passed.</p>

<pre>void getDirectory (
  in DOMString <em>path</em>, in optional Flags <em>options</em>
) raises (<a href="https://developer.mozilla.org/en/DOM/File_API/File_System_API/FileException">FileException</a>);</pre>

<h5 id="Parameter_3">Parameter</h5>

<dl>
	<dt>path</dt>
	<dd>Either an absolute path or a relative path from the directory to the file to be looked up or created. You cannot create a file whose immediate parent does not exist. Create the parent directory first.</dd>
	<dt>options</dt>
	<dd>An object literal describing the behavior of the method if the file does not exist.</dd>
</dl>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Object literal</th>
			<th scope="col">Condition</th>
			<th scope="col">Result</th>
		</tr>
		<tr>
			<td><code>create: true</code><br>
			<code>exclusive: true</code></td>
			<td>Path already exists</td>
			<td>An error is thrown.</td>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><code>create: true</code><br>
			<code>exclusive: false</code></td>
			<td>Path doesn't exist and no other error occurs</td>
			<td>A directory is created. If a file already exists, no error is thrown.</td>
		</tr>
		<tr>
			<td><code>create: false</code><br>
			(<code>exclusive</code> is ignored)</td>
			<td>Path exists</td>
			<td>The directory is returned.</td>
		</tr>
		<tr>
			<td><code>create: false</code><br>
			(<code>exclusive</code> is ignored)</td>
			<td>Path doesn't exist</td>
			<td>An error is thrown.</td>
		</tr>
		<tr>
			<td><code>create: false</code><br>
			(<code>exclusive</code> is ignored)</td>
			<td>Path exists, but is a directory</td>
			<td>An error is thrown.</td>
		</tr>
	</tbody>
</table>

<h5 id="Returns_3">Returns</h5>

<dl>
	<dt><a href="/en/DOM/File_API/File_System_API/DirectoryReaderSync" title="en/DOM/File_API/File_System_API/DirectoryReaderSync"><code>DirectoryEntrySync</code></a></dt>
	<dd>Represents a directory in a file system.</dd>
</dl>

<h5 id="Exceptions_3">Exceptions</h5>

<p>This method can raise a <a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a> with the following codes:</p>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Exception</th>
			<th scope="col">Description</th>
		</tr>
		<tr>
			<td><code>ENCODING_ERR</code></td>
			<td>The path supplied is invalid.</td>
		</tr>
		<tr>
			<td><code>NOT_FOUND_ERR</code></td>
			<td>The path was structurally correct, but refers to a resource that does not exist.</td>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><code>NO_MODIFICATION_ALLOWED_ERR</code></td>
			<td>This is a permission issue. The target directory or file is not writable.</td>
		</tr>
		<tr>
			<td><code>PATH_EXISTS_ERR</code></td>
			<td>The file already exists. You cannot create another one with the same path.</td>
		</tr>
		<tr>
			<td><code>QUOTA_EXCEEDED_ERROR</code></td>
			<td>The operation would cause the application to exceed its storage quota.</td>
		</tr>
		<tr>
			<td><code>SECURITY_ERR</code></td>
			<td>The application does not have permission to access the element referred to by path. [ todo: Explain why ]</td>
		</tr>
		<tr>
			<td><code>TYPE_MISMATCH_ERR</code></td>
			<td>The path supplied exists, but it is not a directory.</td>
		</tr>
	</tbody>
</table>

<h3 id="removeRecursively">removeRecursively()</h3>

<p>Deletes a directory and all of its contents. You cannot delete the root directory of a file system.</p>

<p>If you delete a directory that contains a file that cannot be removed or if an error occurs while the deletion is in progress, some of the contents might not be deleted. Catch these cases with error callbacks and retry the deletion.</p>

<pre>void removeRecursively (
)  raises (<a href="https://developer.mozilla.org/en/DOM/File_API/File_System_API/FileException">FileException</a>);</pre>

<h5 id="Parameter_4">Parameter</h5>

<p>None</p>

<h5 id="Returns_4">Returns</h5>

<p><code>void</code></p>

<h5 id="Exceptions_4">Exceptions</h5>

<p>This method can raise a <a href="/en/DOM/File_API/File_System_API/FileException" title="en/DOM/File_API/File_System_API/FileException">FileException</a> with the following codes:</p>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Exception</th>
			<th scope="col">Description</th>
		</tr>
		<tr>
			<td><code>NOT_FOUND_ERR</code></td>
			<td>The target directory does not exist.</td>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><code>INVALID_STATE_ERR</code></td>
			<td>This directory is not longer valid for some reason other than being deleted.
			<p>[todo: Explain more ]</p>
			</td>
		</tr>
		<tr>
			<td><code>NO_MODIFICATION_ALLOWED_ERR</code></td>
			<td>One of the following is not writable: the directory, its parent directory, and some of the content in the directory.</td>
		</tr>
		<tr>
			<td><code>SECURITY_ERR</code></td>
			<td>The application does not have permission to access the target directory, its parent, or some of its contents.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.DirectoryEntrySync")}}</p>
</div>

<h2 id="See_also">See also</h2>

<p>Specification: {{ spec("http://dev.w3.org/2009/dap/file-system/pub/FileSystem/", "File API: Directories and System Specification", "WD") }}</p>

<p>Reference: <a href="/en/DOM/File_API/File_System_API" title="en/DOM/File_API/File_System_API">File System API</a></p>

<p>Introduction: <a href="/en/DOM/File_APIs/Filesystem/Basic_Concepts_About_the_Filesystem_API" title="en/DOM/File_APIs/Filesystem/Basic_Concepts_About_the_Filesystem_API">Basic Concepts About the File System API</a></p>
